// Generated by psc version 0.8.0.0
"use strict";
var $foreign = require("./foreign");
var Prelude = require("../Prelude");
var Data_Argonaut_Parser = require("../Data.Argonaut.Parser");
var Data_Argonaut_Decode = require("../Data.Argonaut.Decode");
var Data_Array = require("../Data.Array");
var Data_Either = require("../Data.Either");
var Data_Foldable = require("../Data.Foldable");
var Data_StrMap_ST = require("../Data.StrMap.ST");
var Data_Maybe = require("../Data.Maybe");
var Data_Set = require("../Data.Set");
var Data_String = require("../Data.String");
var Control_Monad_Eff = require("../Control.Monad.Eff");
var Control_Monad_Eff_Console = require("../Control.Monad.Eff.Console");
var Control_Monad_Eff_Exception = require("../Control.Monad.Eff.Exception");
var Control_Monad_ST = require("../Control.Monad.ST");
var Control_Apply = require("../Control.Apply");
var Node_Process = require("../Node.Process");
var Node_ChildProcess = require("../Node.ChildProcess");
var Node_Stream = require("../Node.Stream");
var Node_Buffer = require("../Node.Buffer");
var Node_Encoding = require("../Node.Encoding");
var Node_FS = require("../Node.FS");
var Node_FS_Sync = require("../Node.FS.Sync");
var Psa = require("../Psa");
var Psa_Printer_Default = require("../Psa.Printer.Default");
var Psa_Types = require("../Psa.Types");
var Psa_Output = require("../Psa.Output");
var Data_Posix_Signal = require("../Data.Posix.Signal");
var usage = "psa - Error/Warning reporting frontend for psc \n\nUsage: psa [--censor-lib] [--censor-src]\n           [--censor-codes=CODES] [--filter-codes=CODES]\n           [--no-colors] [--no-source]\n           [--lib-dir=DIR] [--psc=PSC]\n           PSC_OPTIONS\n\nAvailable options:\n  -v,--version           Show the version number\n  -h,--help              Show this help text\n  --censor-warnings      Censor all warnings\n  --censor-lib           Censor warnings from library sources\n  --censor-src           Censor warnings from project sources\n  --censor-codes=CODES   Censor specific error codes\n  --filter-codes=CODES   Only show specific error codes\n  --no-colors            Disable ANSI colors\n  --no-source            Disable original source code printing\n  --lib-dir=DIR          Distinguishing key for lib sources (defaults to 'bower_components')\n  --psc=PSC              Name of psc executable (defaults to 'psc')\n\n  CODES                  Comma-separated list of psc error codes\n  PSC_OPTIONS            Any extra options are passed to psc\n";
var parseOptions = function (opts) {
    var isPrefix = function (s) {
        return function (str) {
            var $13 = Data_String.indexOf(s)(str);
            if ($13 instanceof Data_Maybe.Just && $13.value0 === 0) {
                return true;
            };
            return false;
        };
    };
    var parse = function (p) {
        return function (arg) {
            if (Prelude["=="](Prelude.eqString)(arg)("--version") || Prelude["=="](Prelude.eqString)(arg)("-v")) {
                return Control_Apply["*>"](Control_Monad_Eff.applyEff)(Control_Monad_Eff_Console.log($foreign.version))(Node_Process.exit(0));
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--help") || Prelude["=="](Prelude.eqString)(arg)("-h")) {
                return Control_Apply["*>"](Control_Monad_Eff.applyEff)(Control_Monad_Eff_Console.log(usage))(Node_Process.exit(0));
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--no-source")) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $17 = {};
                    for (var $18 in p) {
                        if (p.hasOwnProperty($18)) {
                            $17[$18] = p[$18];
                        };
                    };
                    $17.showSource = false;
                    return $17;
                })());
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--no-colors")) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $21 = {};
                    for (var $22 in p) {
                        if (p.hasOwnProperty($22)) {
                            $21[$22] = p[$22];
                        };
                    };
                    $21.opts = (function () {
                        var $19 = {};
                        for (var $20 in p.opts) {
                            if (p.opts.hasOwnProperty($20)) {
                                $19[$20] = p.opts[$20];
                            };
                        };
                        $19.ansi = false;
                        return $19;
                    })();
                    return $21;
                })());
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--censor-warnings")) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $25 = {};
                    for (var $26 in p) {
                        if (p.hasOwnProperty($26)) {
                            $25[$26] = p[$26];
                        };
                    };
                    $25.opts = (function () {
                        var $23 = {};
                        for (var $24 in p.opts) {
                            if (p.opts.hasOwnProperty($24)) {
                                $23[$24] = p.opts[$24];
                            };
                        };
                        $23.censorWarnings = true;
                        return $23;
                    })();
                    return $25;
                })());
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--censor-lib")) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $29 = {};
                    for (var $30 in p) {
                        if (p.hasOwnProperty($30)) {
                            $29[$30] = p[$30];
                        };
                    };
                    $29.opts = (function () {
                        var $27 = {};
                        for (var $28 in p.opts) {
                            if (p.opts.hasOwnProperty($28)) {
                                $27[$28] = p.opts[$28];
                            };
                        };
                        $27.censorLib = true;
                        return $27;
                    })();
                    return $29;
                })());
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--censor-lib")) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $33 = {};
                    for (var $34 in p) {
                        if (p.hasOwnProperty($34)) {
                            $33[$34] = p[$34];
                        };
                    };
                    $33.opts = (function () {
                        var $31 = {};
                        for (var $32 in p.opts) {
                            if (p.opts.hasOwnProperty($32)) {
                                $31[$32] = p.opts[$32];
                            };
                        };
                        $31.censorLib = true;
                        return $31;
                    })();
                    return $33;
                })());
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--censor-src")) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $37 = {};
                    for (var $38 in p) {
                        if (p.hasOwnProperty($38)) {
                            $37[$38] = p[$38];
                        };
                    };
                    $37.opts = (function () {
                        var $35 = {};
                        for (var $36 in p.opts) {
                            if (p.opts.hasOwnProperty($36)) {
                                $35[$36] = p.opts[$36];
                            };
                        };
                        $35.censorSrc = true;
                        return $35;
                    })();
                    return $37;
                })());
            };
            if (isPrefix("--censor-codes=")(arg)) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $41 = {};
                    for (var $42 in p) {
                        if (p.hasOwnProperty($42)) {
                            $41[$42] = p[$42];
                        };
                    };
                    $41.opts = (function () {
                        var $39 = {};
                        for (var $40 in p.opts) {
                            if (p.opts.hasOwnProperty($40)) {
                                $39[$40] = p.opts[$40];
                            };
                        };
                        $39.censorCodes = Data_Foldable.foldr(Data_Foldable.foldableArray)(Data_Set.insert(Prelude.ordString))(p.opts.censorCodes)(Data_String.split(",")(Data_String.drop(15)(arg)));
                        return $39;
                    })();
                    return $41;
                })());
            };
            if (isPrefix("--filter-codes=")(arg)) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $45 = {};
                    for (var $46 in p) {
                        if (p.hasOwnProperty($46)) {
                            $45[$46] = p[$46];
                        };
                    };
                    $45.opts = (function () {
                        var $43 = {};
                        for (var $44 in p.opts) {
                            if (p.opts.hasOwnProperty($44)) {
                                $43[$44] = p.opts[$44];
                            };
                        };
                        $43.filterCodes = Data_Foldable.foldr(Data_Foldable.foldableArray)(Data_Set.insert(Prelude.ordString))(p.opts.filterCodes)(Data_String.split(",")(Data_String.drop(15)(arg)));
                        return $43;
                    })();
                    return $45;
                })());
            };
            if (isPrefix("--lib-dir=")(arg)) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $49 = {};
                    for (var $50 in p) {
                        if (p.hasOwnProperty($50)) {
                            $49[$50] = p[$50];
                        };
                    };
                    $49.opts = (function () {
                        var $47 = {};
                        for (var $48 in p.opts) {
                            if (p.opts.hasOwnProperty($48)) {
                                $47[$48] = p.opts[$48];
                            };
                        };
                        $47.libDir = Data_String.drop(10)(arg);
                        return $47;
                    })();
                    return $49;
                })());
            };
            if (isPrefix("--lib-dir=")(arg)) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $53 = {};
                    for (var $54 in p) {
                        if (p.hasOwnProperty($54)) {
                            $53[$54] = p[$54];
                        };
                    };
                    $53.opts = (function () {
                        var $51 = {};
                        for (var $52 in p.opts) {
                            if (p.opts.hasOwnProperty($52)) {
                                $51[$52] = p.opts[$52];
                            };
                        };
                        $51.libDir = Data_String.drop(10)(arg);
                        return $51;
                    })();
                    return $53;
                })());
            };
            if (isPrefix("--psc=")(arg)) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $55 = {};
                    for (var $56 in p) {
                        if (p.hasOwnProperty($56)) {
                            $55[$56] = p[$56];
                        };
                    };
                    $55.psc = Data_String.drop(6)(arg);
                    return $55;
                })());
            };
            if (Prelude.otherwise) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $57 = {};
                    for (var $58 in p) {
                        if (p.hasOwnProperty($58)) {
                            $57[$58] = p[$58];
                        };
                    };
                    $57.extra = Data_Array.snoc(p.extra)(arg);
                    return $57;
                })());
            };
            throw new Error("Failed pattern match at Main line 80, column 1 - line 85, column 1: " + [ p.constructor.name, arg.constructor.name ]);
        };
    };
    return Data_Array.foldM(Control_Monad_Eff.monadEff)(parse)({
        extra: [  ], 
        psc: "psc", 
        showSource: true, 
        opts: opts
    });
};
var defaultOptions = {
    ansi: true, 
    censorWarnings: false, 
    censorLib: false, 
    censorSrc: false, 
    censorCodes: Data_Set.empty, 
    filterCodes: Data_Set.empty, 
    libDir: "bower_components", 
    cwd: ""
};
var main = (function () {
    
    /**
     *  TODO: Handle exceptions
     */
    var loadNothing = function (v) {
        return function (v1) {
            return Prelude.pure(Control_Monad_Eff.applicativeEff)(Data_Maybe.Nothing.value);
        };
    };
    var loadLines = function (files) {
        return function (filename) {
            return function (pos) {
                return function __do() {
                    var v = (function __do() {
                        var cache = Data_StrMap_ST.peek(files)(filename)();
                        if (cache instanceof Data_Maybe.Just) {
                            return cache.value0;
                        };
                        if (cache instanceof Data_Maybe.Nothing) {
                            var v = Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_String.split("\n"))(Node_FS_Sync.readTextFile(Node_Encoding.UTF8.value)(filename))();
                            Data_StrMap_ST.poke(files)(filename)(v)();
                            return v;
                        };
                        throw new Error("Failed pattern match at Main line 151, column 1 - line 152, column 1: " + [ cache.constructor.name ]);
                    })();
                    return Data_Maybe.Just.create(Data_Array.slice(pos.startLine - 1)(pos.endLine)(v));
                };
            };
        };
    };
    return Prelude["void"](Control_Monad_Eff.functorEff)(function __do() {
        var v = Node_Process.cwd();
        var v1 = Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_Array.drop(2))(Node_Process.argv)();
        var v2 = parseOptions((function () {
            var $65 = {};
            for (var $66 in defaultOptions) {
                if (defaultOptions.hasOwnProperty($66)) {
                    $65[$66] = defaultOptions[$66];
                };
            };
            $65.cwd = v;
            return $65;
        })())(v1)();
        var v3 = Node_ChildProcess.spawn(v2.psc)(Data_Array.cons("--json-errors")(v2.extra))(Node_ChildProcess.defaultSpawnOptions)();
        var v4 = Data_StrMap_ST["new"]();
        var v5 = Control_Monad_ST.newSTRef("")();
        Node_Stream.pipe(Node_ChildProcess.stdout(v3))(Node_Process.stdout)();
        Node_Stream.onDataString(Node_ChildProcess.stderr(v3))(Node_Encoding.UTF8.value)(function (chunk) {
            return Prelude["void"](Control_Monad_Eff.functorEff)(Control_Monad_ST.modifySTRef(v5)(function (v6) {
                return v6 + chunk;
            }));
        })();
        return Node_ChildProcess.onExit(v3)(function (status) {
            if (status instanceof Node_ChildProcess.Normally) {
                return function __do() {
                    var v6 = Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_String.split("\n"))(Control_Monad_ST.readSTRef(v5))();
                    Data_Foldable.for_(Control_Monad_Eff.applicativeEff)(Data_Foldable.foldableArray)(v6)(function (err) {
                        var $73 = Prelude[">>="](Data_Either.bindEither)(Prelude[">>="](Data_Either.bindEither)(Data_Argonaut_Parser.jsonParser(err))(Data_Argonaut_Decode.decodeJson(Data_Argonaut_Decode.decodeStrMap(Data_Argonaut_Decode.decodeJsonJson))))(Psa_Types.parsePsaResult);
                        if ($73 instanceof Data_Either.Left) {
                            return Control_Monad_Eff_Console.error(err);
                        };
                        if ($73 instanceof Data_Either.Right) {
                            return function __do() {
                                var v7 = Psa_Output.output(Control_Monad_Eff.monadEff)((function () {
                                    if (v2.showSource) {
                                        return loadLines(v4);
                                    };
                                    if (!v2.showSource) {
                                        return loadNothing;
                                    };
                                    throw new Error("Failed pattern match at Main line 151, column 1 - line 152, column 1: " + [ v2.showSource.constructor.name ]);
                                })())(v2.opts)($73.value0)();
                                return Psa_Printer_Default.print(v2.opts)(v7)();
                            };
                        };
                        throw new Error("Failed pattern match at Main line 151, column 1 - line 152, column 1: " + [ $73.constructor.name ]);
                    })();
                    return Node_Process.exit(status.value0)();
                };
            };
            if (status instanceof Node_ChildProcess.BySignal) {
                return function __do() {
                    Control_Monad_Eff_Console.error(Prelude.show(Data_Posix_Signal.showSignal)(status.value0))();
                    return Node_Process.exit(1)();
                };
            };
            throw new Error("Failed pattern match at Main line 151, column 1 - line 152, column 1: " + [ status.constructor.name ]);
        })();
    });
})();
module.exports = {
    main: main, 
    parseOptions: parseOptions, 
    defaultOptions: defaultOptions, 
    usage: usage, 
    version: $foreign.version
};
