// Generated by psc version 0.8.0.0
"use strict";
var Prelude = require("../Prelude");
var Data_Array = require("../Data.Array");
var Data_Foldable = require("../Data.Foldable");
var Data_Maybe = require("../Data.Maybe");
var Data_Monoid = require("../Data.Monoid");
var Data_String = require("../Data.String");
var Data_String_Regex = require("../Data.String.Regex");
var Data_Tuple = require("../Data.Tuple");
var Control_Monad_Eff = require("../Control.Monad.Eff");
var Control_Monad_Eff_Console = require("../Control.Monad.Eff.Console");
var Ansi_Output = require("../Ansi.Output");
var Ansi_Codes = require("../Ansi.Codes");
var Psa_Types = require("../Psa.Types");
var Psa_Output = require("../Psa.Output");
var Psa_Printer = require("../Psa.Printer");
var Psa_Util = require("../Psa.Util");
var toLines = function ($21) {
    return Psa_Printer.para(Prelude.map(Prelude.functorArray)(function ($22) {
        return Psa_Printer.line(Data_Array.singleton(Psa_Printer.plain($22)));
    })(Data_String.split("\n")($21)));
};
var renderStatus = function (gfx) {
    return function (total) {
        return function (index) {
            return function (code) {
                return Psa_Printer.style(gfx)("[" + (Prelude.show(Prelude.showInt)(index) + ("/" + (Prelude.show(Prelude.showInt)(total) + (" " + (code + "]"))))));
            };
        };
    };
};
var renderStat = function (v) {
    if (v.value0 === 0 && v.value1 === 0) {
        return [ Psa_Printer.style(Ansi_Output.foreground(Ansi_Codes.Green.value))("0") ];
    };
    if (v.value0 === v.value1) {
        return [ Psa_Printer.plain(Prelude.show(Prelude.showInt)(v.value0)) ];
    };
    return [ Psa_Printer.plain(Prelude.show(Prelude.showInt)(v.value0)), Psa_Printer.style(Ansi_Output.foreground(Ansi_Codes.Grey.value))("/" + Prelude.show(Prelude.showInt)(v.value1)) ];
};
var renderStats = function (stats) {
    var lineLength = function ($23) {
        return Data_Foldable.sum(Data_Foldable.foldableArray)(Prelude.semiringInt)(Prelude.map(Prelude.functorArray)(Psa_Printer.ansiLength)($23));
    };
    var gutter = [ Psa_Printer.plain("   ") ];
    var catRow = function (c1) {
        return function (c2) {
            return function (c3) {
                return function (c4) {
                    return Psa_Printer.line(Prelude["<>"](Prelude.semigroupArray)(c1)(Prelude["<>"](Prelude.semigroupArray)(gutter)(Prelude["<>"](Prelude.semigroupArray)(c2)(Prelude["<>"](Prelude.semigroupArray)(gutter)(Prelude["<>"](Prelude.semigroupArray)(c3)(Prelude["<>"](Prelude.semigroupArray)(gutter)(c4)))))));
                };
            };
        };
    };
    var align = function (f) {
        return function (ls) {
            var max = Data_Maybe.fromMaybe(0)(Data_Foldable.maximum(Prelude.ordInt)(Data_Foldable.foldableArray)(Prelude.map(Prelude.functorArray)(lineLength)(ls)));
            var pad = function (l) {
                return f(Psa_Printer.plain(Psa_Util.replicate(Data_Monoid.monoidString)(max - lineLength(l))(" ")))(l);
            };
            return Prelude.map(Prelude.functorArray)(pad)(ls);
        };
    };
    var alignLeft = align(function (a) {
        return function (as) {
            return Data_Array.snoc(as)(a);
        };
    });
    var alignRight = align(function (a) {
        return function (as) {
            return Data_Array.cons(a)(as);
        };
    });
    return Psa_Printer.para(Data_Array.zipWith(Prelude["$"])(Data_Array.zipWith(Prelude["$"])(Data_Array.zipWith(Prelude["$"])(Prelude.map(Prelude.functorArray)(catRow)(alignLeft([ [ Psa_Printer.plain("") ], [ Psa_Printer.style(Ansi_Output.foreground(Ansi_Codes.Yellow.value))("Warnings") ], [ Psa_Printer.style(Ansi_Output.foreground(Ansi_Codes.Red.value))("Errors") ] ])))(alignLeft([ [ Psa_Printer.plain("Src") ], renderStat(stats.srcWarnings), renderStat(stats.srcErrors) ])))(alignLeft([ [ Psa_Printer.plain("Lib") ], renderStat(stats.libWarnings), renderStat(stats.libErrors) ])))(alignLeft([ [ Psa_Printer.plain("All") ], renderStat(stats.allWarnings), renderStat(stats.allErrors) ])));
};
var renderPosition = function (pos) {
    return [ Psa_Printer.style(Ansi_Output.foreground(Ansi_Codes.Grey.value))(":"), Psa_Printer.plain(Prelude.show(Prelude.showInt)(pos.startLine)), Psa_Printer.style(Ansi_Output.foreground(Ansi_Codes.Grey.value))(":"), Psa_Printer.plain(Prelude.show(Prelude.showInt)(pos.startColumn)) ];
};
var renderPath = function (v) {
    if (v instanceof Psa_Types.Src) {
        return Psa_Printer.plain(v.value0);
    };
    if (v instanceof Psa_Types.Lib) {
        return Psa_Printer.plain(v.value0);
    };
    return Psa_Printer.plain("");
};
var indented = Psa_Printer.indent([ Psa_Printer.plain("  ") ]);
var emptyLine = Psa_Printer.line([ Psa_Printer.plain("") ]);
var renderSource$prime = function (pos) {
    return function (lines) {
        return Prelude["<>"](Psa_Printer.semigroupRow)(Psa_Printer.renderSource(pos)(lines))(emptyLine);
    };
};
var render = function (gfx) {
    return function (total) {
        return function (index) {
            return function (v) {
                return Psa_Printer.para([ Psa_Printer.line(Prelude["<>"](Prelude.semigroupArray)([ renderStatus(gfx)(total)(index)(v.error.errorCode), Psa_Printer.plain(" "), renderPath(v.path) ])(Data_Maybe.fromMaybe(Data_Monoid.mempty(Data_Monoid.monoidArray))(Prelude["<$>"](Data_Maybe.functorMaybe)(renderPosition)(v.position)))), emptyLine, indented(Prelude["<>"](Psa_Printer.semigroupRow)(Data_Maybe.fromMaybe(Data_Monoid.mempty(Psa_Printer.monoidRow))(Prelude["<*>"](Data_Maybe.applyMaybe)(Prelude["<$>"](Data_Maybe.functorMaybe)(renderSource$prime)(v.position))(v.source)))(toLines(v.error.message))) ]);
            };
        };
    };
};
var renderError = render(Ansi_Output.foreground(Ansi_Codes.Red.value));
var renderWarning = render(Ansi_Output.foreground(Ansi_Codes.Yellow.value));

/**
 *  | Prints output to the console. Errors and warnings will be directed to
 *  | stderr, while statistics will be directed to stdout.
 */
var print = function (options) {
    return function (output) {
        var toString = Psa_Printer.renderRow(function ($24) {
            return Data_String.joinWith("")(Prelude.map(Prelude.functorArray)(Psa_Printer.renderAnsi(options.ansi))($24));
        });
        var lenWarnings = Data_Array.length(output.warnings);
        var lenErrors = Data_Array.length(output.errors);
        return function __do() {
            Psa_Util.iter_(Data_Foldable.foldableArray)(Control_Monad_Eff.applicativeEff)(output.warnings)(function (i) {
                return function (warning) {
                    return function __do() {
                        Control_Monad_Eff_Console.error(toString(renderWarning(lenWarnings)(i + 1 | 0)(warning)))();
                        return Control_Monad_Eff_Console.error("")();
                    };
                };
            })();
            Psa_Util.iter_(Data_Foldable.foldableArray)(Control_Monad_Eff.applicativeEff)(output.errors)(function (i) {
                return function (error) {
                    return function __do() {
                        Control_Monad_Eff_Console.error(toString(renderError(lenErrors)(i + 1 | 0)(error)))();
                        return Control_Monad_Eff_Console.error("")();
                    };
                };
            })();
            return Control_Monad_Eff_Console.log(toString(renderStats(output.stats)))();
        };
    };
};
module.exports = {
    print: print, 
    renderStats: renderStats, 
    renderError: renderError, 
    renderWarning: renderWarning
};
